name: CI

on:
  pull_request:
  merge_group:

defaults:
  run:
    shell: bash

jobs:
  ci:
    strategy:
      matrix:
        os: [ubuntu-latest, macos-latest, windows-latest]
    runs-on: ${{ matrix.os }}
    steps:
      - name: Install QEMU (ubuntu)
        if: matrix.os == 'ubuntu-latest'
        run: |
          sudo apt-get update
          sudo apt-get install qemu-system-x86
      - name: Install QEMU (macos)
        if: matrix.os == 'macos-latest'
        run: |
          # TODO: Enable once it works again
          # brew update
          brew install qemu
      - name: Install QEMU (windows)
        if: matrix.os == 'windows-latest'
        run: |
          choco install qemu
          echo "C:\Program Files\qemu" >> $GITHUB_PATH
      - uses: actions/checkout@v3
      - uses: mkroening/rust-toolchain-toml@main
      - name: Download rust-std-hermit
        uses: dsaltares/fetch-gh-release-asset@master
        with:
          repo: hermit-os/rust-std-hermit
          version: tags/1.74.0
          file: rust-std-1.74.0-x86_64-unknown-hermit.tar.gz
      - name: Install rust-std-hermit
        run: |
          tar xvf rust-std-1.74.0-x86_64-unknown-hermit.tar.gz
          ./rust-std-1.74.0-x86_64-unknown-hermit/install.sh
      - name: Download loader
        uses: dsaltares/fetch-gh-release-asset@master
        with:
          repo: hermit-os/loader
          file: hermit-loader-x86_64
      - name: Building dev version
        run: cargo build --target x86_64-unknown-hermit --locked
      - name: Run dev version
        run: |
          qemu-system-x86_64 \
            -cpu qemu64,apic,fsgsbase,fxsr,rdrand,rdtscp,xsave,xsaveopt \
            -smp 1 -m 128M \
            -device isa-debug-exit,iobase=0xf4,iosize=0x04 \
            -display none -serial stdio \
            -kernel hermit-loader-x86_64 \
            -initrd target/x86_64-unknown-hermit/debug/hermit-rs-template
      - name: Building release version
        run: cargo build --target x86_64-unknown-hermit --locked --release
      - name: Run release version
        run: |
          qemu-system-x86_64 \
            -cpu qemu64,apic,fsgsbase,fxsr,rdrand,rdtscp,xsave,xsaveopt \
            -smp 1 -m 128M \
            -device isa-debug-exit,iobase=0xf4,iosize=0x04 \
            -display none -serial stdio \
            -kernel hermit-loader-x86_64 \
            -initrd target/x86_64-unknown-hermit/release/hermit-rs-template
